//
//  CategoryListProtocols.swift
//  xsea
//
//  Created Phạm Anh Tuấn on 8/31/19.
//  Copyright © 2019 Phạm Anh Tuấn. All rights reserved.
//
//  Template generated by Juanpe Catalán @JuanpeCMiOS
//

import Foundation
import UIKit

//MARK: Wireframe -
protocol CategoryListWireframeProtocol: class {
    func pushToCategoryDetail(selecttionCategory: Category , navColor: UIColor)

}
//MARK: Presenter -
protocol CategoryListPresenterProtocol: class {

    var categories: [Category] {get set}
    var interactor: CategoryListInteractorInputProtocol? { get set }
    
    func getCategories()
    func showCategoryDetail(selectedIndex: Int)
}

//MARK: Interactor -
protocol CategoryListInteractorOutputProtocol: class {

    /* Interactor -> Presenter */
    func categoryListDidFetch(categories : [Category])
}

protocol CategoryListInteractorInputProtocol: class {

    var presenter: CategoryListInteractorOutputProtocol?  { get set }

    /* Presenter -> Interactor */
    func getCategories()
}

//MARK: View -
protocol CategoryListViewProtocol: class {

    var presenter: CategoryListPresenterProtocol?  { get set }

    /* Presenter -> ViewController */
    
    func showCategories()
}
